CREATE TABLE IF NOT EXISTS `TABLE_GLOBALBLOCKLIST` (
  `id` int(11) NOT NULL auto_increment,
  `u_EMail` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `u_EMail` (`u_EMail`(191))
);

CREATE TABLE IF NOT EXISTS `TABLE_GLOBALDOMAINBLOCKLIST` (
  `id` int(11) NOT NULL auto_increment,
  `Domainname` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `Domainname` (`Domainname`(191))
);

CREATE TABLE IF NOT EXISTS `TABLE_MESSAGES` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsDefault` tinyint(1) NOT NULL default '0',
  `Name` varchar(191) NOT NULL,
  `EMailFormatErrorText` mediumtext NOT NULL,
  `RequiredFieldsErrorText` mediumtext NOT NULL,
  `ErrorText` mediumtext NOT NULL,
  `SubscribeOKText` mediumtext NOT NULL,
  `SubscribeTextConfirmationRequired` mediumtext NOT NULL,
  `EMailAddressAlwaysInList` mediumtext NOT NULL,
  `EMailAddressBlacklisted` mediumtext NOT NULL,
  `UnsubscribeOKText` mediumtext NOT NULL,
  `UnsubscribeTextConfirmationRequired` mediumtext NOT NULL,
  `EMailAddressNotInList` mediumtext NOT NULL,
  `SubscribeTextOnConfirmationSucc` mediumtext NOT NULL,
  `UnsubscribeTextOnConfirmationSucc` mediumtext NOT NULL,
  `SubscribeTextOnConfirmationFailure` mediumtext NOT NULL,
  `UnsubscribeTextOnConfirmationFailure` mediumtext NOT NULL,
  `SubscribeTextOnConfirmationAgain` mediumtext NOT NULL,
  `CaptchaStringIncorrect` mediumtext NOT NULL,
  `GroupsAsMandatoryFieldError` mediumtext NOT NULL,
  `PrivacyPolicyAcceptanceError` mediumtext NOT NULL,
  `u_EMail` mediumtext NOT NULL,
  `u_EMailFormat` mediumtext NOT NULL,
  `u_CustomerNo` mediumtext NOT NULL,
  `u_Firm` mediumtext NOT NULL,
  `u_Gender` mediumtext NOT NULL,
  `u_Salutation` mediumtext NOT NULL,
  `u_Profession` mediumtext NOT NULL,
  `u_FirstName` mediumtext NOT NULL,
  `u_MiddleName` mediumtext NOT NULL,
  `u_LastName` mediumtext NOT NULL,
  `u_CellNumber` mediumtext NOT NULL,
  `u_Birthday` mediumtext NOT NULL,
  `u_MessengerICQ` mediumtext NOT NULL,
  `u_MessengerMSN` mediumtext NOT NULL,
  `u_MessengerYAHOO` mediumtext NOT NULL,
  `u_MessengerAOL` mediumtext NOT NULL,
  `u_MessengerOther` mediumtext NOT NULL,
  `u_PrivateStreet` mediumtext NOT NULL,
  `u_PrivateZIPCode` mediumtext NOT NULL,
  `u_PrivateCity` mediumtext NOT NULL,
  `u_PrivateState` mediumtext NOT NULL,
  `u_PrivateCountry` mediumtext NOT NULL,
  `u_PrivateWebsite` mediumtext NOT NULL,
  `u_PrivateTelephone` mediumtext NOT NULL,
  `u_PrivateFax` mediumtext NOT NULL,
  `u_BusinessStreet` mediumtext NOT NULL,
  `u_BusinessZIPCode` mediumtext NOT NULL,
  `u_BusinessCity` mediumtext NOT NULL,
  `u_BusinessState` mediumtext NOT NULL,
  `u_BusinessCountry` mediumtext NOT NULL,
  `u_BusinessWebsite` mediumtext NOT NULL,
  `u_BusinessTelephone` mediumtext NOT NULL,
  `u_BusinessFax` mediumtext NOT NULL,
  `u_BusinessPosition` mediumtext NOT NULL,
  `u_BusinessDepartment` mediumtext NOT NULL,
  `u_Comments` mediumtext NOT NULL,
  `u_Username` mediumtext NOT NULL,
  `u_Password` mediumtext NOT NULL,
  `u_Language` mediumtext NOT NULL,
  `u_UserFieldString1` mediumtext NOT NULL,
  `u_UserFieldString2` mediumtext NOT NULL,
  `u_UserFieldString3` mediumtext NOT NULL,
  `u_UserFieldInt1` mediumtext NOT NULL,
  `u_UserFieldInt2` mediumtext NOT NULL,
  `u_UserFieldInt3` mediumtext NOT NULL,
  `u_UserFieldBool1` mediumtext NOT NULL,
  `u_UserFieldBool2` mediumtext NOT NULL,
  `u_UserFieldBool3` mediumtext NOT NULL,
  `u_PersonalizedTracking` mediumtext NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_FUNCTIONS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsDefault` tinyint(1) NOT NULL default '0',
  `Name` varchar(191) NOT NULL,
  `functiontext` text NOT NULL,
  PRIMARY KEY  (`id`)
);

CREATE TABLE IF NOT EXISTS `TABLE_TARGETGROUPS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsDefault` tinyint(1) NOT NULL default '0',
  `Name` varchar(191) NOT NULL,
  `functiontext` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_MTAS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsDefault` tinyint(1) NOT NULL default '0',
  `Type` enum('mail','sendmail','smtp','smtpmx', 'savetodir') NOT NULL,
  `Name` varchar(191) NOT NULL,
  `MailLimit` bigint(20) NOT NULL default '0',
  `MTASenderEMailAddress` varchar(255) NOT NULL default '',
  `SleepInMailSendingLoop` int(2) NOT NULL default '0',
  `MailLimitWaitTime` int(11) NOT NULL default '10',
  `MailLimitDateTime` datetime  NOT NULL,
  `PHPMailParams` varchar(255) NOT NULL,
  `HELOName` varchar(255) NOT NULL default 'localhost',
  `SMTPPersist` tinyint(1) NOT NULL default '0',
  `SMTPPipelining` tinyint(1) NOT NULL default '0',
  `SMTPTimeout` int(4) NOT NULL default '20',
  `SMTPServer` varchar(255) NOT NULL,
  `SMTPPort` int(2) NOT NULL default '25',
  `SMTPAuth` tinyint(1) NOT NULL default '0',
  `SMTPUsername` varchar(255) NOT NULL,
  `SMTPPassword` varchar(255) NOT NULL,
  `SMTPSSL` tinyint(1) NOT NULL default '0',
  `OAuth2Apps_id` int(11) NOT NULL default '0',
  `sendmail_path` varchar(255) NOT NULL default '/usr/sbin/sendmail',
  `sendmail_args` varchar(255) NOT NULL default '-i',
  `savetodir_pathname` varchar(255) NOT NULL,
  `MailThreadCount` int(4) NOT NULL default '1',
  `MailHeaderFields` text,
  `SMIMESignMail` tinyint(1) NOT NULL default '0',
  `SMIMEMessageAsPlainText` tinyint(1) NOT NULL default '1',
  `SMIMESignCert` text,
  `SMIMESignPrivKey` text,
  `SMIMESignPrivKeyPassword` text,
  `SMIMESignExtraCerts` text,
  `SMIMEIgnoreSignErrors` tinyint(1) NOT NULL default '0',
  `DKIM` tinyint(1) NOT NULL default '0',
  `DomainKey` tinyint(1) NOT NULL default '0',
  `DKIMSelector` varchar(255) NOT NULL default '',
  `DKIMPrivKey` text,
  `DKIMPrivKeyPassword` text,
  `DKIMIgnoreSignErrors` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `Type` (`Type`),
  KEY `users_id` (`CreateDate`)
);

CREATE TABLE IF NOT EXISTS `TABLE_PAGES` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsDefault` tinyint(1) NOT NULL default '0',
  `Name` varchar(255) NOT NULL,
  `Type` enum('Subscribe','Unsubscribe','Error','SubscribeConfirmation','UnsubscribeConfirmation','UnsubscribeBridge','Edit','EditConfirmation','EditReject','EditError','RFUSurveyConfirmation') NOT NULL,
  `RedirectURL` varchar(255) NOT NULL,
  `ForceRedirect` tinyint(1) NOT NULL default '0',
  `HTMLPage` mediumtext NOT NULL,
  PRIMARY KEY  (`id`)
);

CREATE TABLE IF NOT EXISTS `TABLE_INBOXES` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `Name` varchar(64) NOT NULL,
  `InboxType` enum('pop3','imap') NOT NULL,
  `EMailAddress` varchar(255) NOT NULL,
  `Servername` varchar(255) NOT NULL,
  `Serverport` int(11) NOT NULL default '110',
  `Username` varchar(255) NOT NULL,
  `Password` varchar(255) NOT NULL,
  `SSL` tinyint(1) NOT NULL default '0',
  `OAuth2Apps_id` int(11) NOT NULL default '0',
  `LeaveMessagesInInbox` tinyint(1) NOT NULL default '0',
  `SubscriptionSubject` varchar(255) NOT NULL,
  `SubscriptionConfirmSubject` varchar(255) NOT NULL,
  `UnsubscriptionSubject` varchar(255) NOT NULL,
  `EditSubject` varchar(255) NOT NULL,
  `UIDL` LONGTEXT NOT NULL,
  PRIMARY KEY  (`id`)
);


CREATE TABLE IF NOT EXISTS `TABLE_MAILSSENTTABLENAME` (
  `id` int(11) NOT NULL auto_increment,
  `MailDate` date NOT NULL,
  `TestEMailCount` int(11) unsigned NOT NULL default '0',
  `AdminNotifyMailCount` int(11) unsigned NOT NULL default '0',
  `OptInConfirmationMailCount` int(11) unsigned NOT NULL default '0',
  `OptInConfirmedMailCount` int(11) unsigned NOT NULL default '0',
  `OptOutConfirmationMailCount` int(11) unsigned NOT NULL default '0',
  `OptOutConfirmedMailCount` int(11) unsigned NOT NULL default '0',
  `EditConfirmationMailCount` int(11) unsigned NOT NULL default '0',
  `EditConfirmedMailCount` int(11) unsigned NOT NULL default '0',
  `AutoresponderEMailCount` int(11) unsigned NOT NULL default '0',
  `BirthdayResponderEMailCount` int(11) unsigned NOT NULL default '0',
  `RSS2EMailResponderEMailCount` int(11) unsigned NOT NULL default '0',
  `FollowUpResponderEMailCount` int(11) unsigned NOT NULL default '0',
  `EventResponderEMailCount` int(11) unsigned NOT NULL default '0',
  `CampaignEMailCount` int(11) unsigned NOT NULL default '0',
  `DistribListEMailCount` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `MailDate` (`MailDate`)
);

CREATE TABLE IF NOT EXISTS `TABLE_AUTOIMPORTS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `Name` varchar(191) NOT NULL,
  `IsActive` tinyint(1) NOT NULL default '1',
  `maillists_id` int(11) default 0,

  `LastImportDate` datetime NOT NULL,
  `LastImportDone` tinyint(1) NOT NULL default '1',

  `LastImportRemoveMode` tinyint(1) NOT NULL default '0',

  `LastRowCount` int(11) NOT NULL default '0',
  `LastImportRowCount` int(11) NOT NULL default '0',

  `LastStartPosition` int(11) NOT NULL default '0',
  `LastFilePosition` int(11) NOT NULL default '0',
  `LastTablePosition` int(11) NOT NULL default '0',

  `ImportScheduler` enum('ImportAtDay','ImportOnceAMonth') NOT NULL default 'ImportAtDay',
  `ImportDayNames` enum('every day','0','1','2','3','4','5','6') NOT NULL default 'every day',
  `ImportMonthDay` enum('none','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','19','20','21','22','23','24','25','26','27','28','29','30','31') NOT NULL default 'none',
  `ImportTime` time NOT NULL,

  `ImportOption` enum('ImportCSV','ImportDB') NOT NULL default 'ImportCSV',
  `ImportFilename` varchar(255) NOT NULL,

  `Separator` varchar(16) NOT NULL default ',',
  `Header1Line` tinyint(1) NOT NULL default '1',
  `RemoveQuotes` tinyint(1) NOT NULL default '1',
  `RemoveSpaces` tinyint(1) NOT NULL default '1',
  `RemoveFile` tinyint(1) NOT NULL default '0',
  `ImportLines` int(11) NOT NULL default '100',
  `IsUTF8` tinyint(1) NOT NULL default '1',
  `ImportBlockedRecipients` tinyint(1) NOT NULL default '0',
  `CreateErrorLog` tinyint(1) NOT NULL default '0',
  `SendOptInEMail` tinyint(1) NOT NULL default '0',
  `BirthdayDateFormat` varchar(32) NOT NULL,
  `IsMacFile` tinyint(1) NOT NULL default '0',

  `RemoveAllRecipients` tinyint(1) NOT NULL default '0',

  `fields` text NOT NULL,
  `GroupsOption` int(1) NOT NULL default '1',
  `ImportGroupField` int(11) NOT NULL,
  `groups_id` int(11) NOT NULL,
  `ExImportOption` int(1) NOT NULL default '1',
  `RemoveRecipientFromGroups` int(1) NOT NULL default '0',

  `DBType` enum('MYSQL','MSSQL') NOT NULL default 'MYSQL',
  `SQLServerName` varchar(255) NOT NULL,
  `SQLDatabase` varchar(255) NOT NULL,
  `SQLUsername` varchar(255) NOT NULL,
  `SQLPassword` varchar(255) NOT NULL,
  `SQLTableName` varchar(255) NOT NULL,
  `SQLExtImport` int(1) NOT NULL default '1',
  `SQLImportSQLQuery` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`),
  KEY `maillists_id` (`maillists_id`)
);

CREATE TABLE IF NOT EXISTS `TABLE_DISTRIB_LISTS` (
  `id` int(11) NOT NULL auto_increment,
  `CreateDate` datetime NOT NULL,
  `IsActive` tinyint(1) NOT NULL default '1',
  `Creator_users_id` int(11) NOT NULL,
  `Name` varchar(191) NOT NULL,
  `Description` text NOT NULL,

  `WorkAsRealMailingList` tinyint(1) NOT NULL default '0',

  `EMailsProcessed` int(11) NOT NULL default '0',
  `EMailsSent` int(11) default 0,

  `maillists_id` int(11) NOT NULL,
  `forms_id` int(11) NOT NULL default '1',
  `inboxes_id` int(11) NOT NULL,
  `LeaveMessagesInInbox` tinyint(1) NOT NULL default '0',

  `ResponderUIDL` longtext NOT NULL,

  `DistribListSubjects` text NOT NULL,
  `MaxEMailsToProcess` int(11) NOT NULL default '1',

  `SendConfirmationRequired` tinyint(1) NOT NULL default '1',
  `AcceptAllSenderEMailAddresses` int(1) NOT NULL default '1',
  `AcceptSenderEMailAddresses` text NOT NULL,
  `SendInfoMailToSender` tinyint(1) NOT NULL default '1',
  `SendConfirmationLinkToThisEMailAddresses` text NOT NULL,

  `ModifiedEMailSubject` text NOT NULL,
  `DontModifyEMailSubjectOnReFw` tinyint(1) NOT NULL default '0',
  `NoPOSTToDistributionList` tinyint(1) NOT NULL default '0',

  `AutoRemoveEMails` tinyint(1) NOT NULL default '0',
  `AutoRemoveEMailDays` int(11) NOT NULL default '30',

  `UserMailHeaderFields` text NOT NULL,

  `CurrentSendTableName` text NOT NULL,
  `CurrentUsedMTAsTableName` text NOT NULL,

  `GroupsTableName` text NOT NULL,
  `NotInGroupsTableName` text NOT NULL,
  `MTAsTableName` text NOT NULL,
  `RStatisticsTableName` text NOT NULL,

  `LinksTableName` text NOT NULL,
  `TrackingOpeningsTableName` text NOT NULL,
  `TrackingOpeningsByRecipientTableName` text NOT NULL,
  `TrackingLinksTableName` text NOT NULL,
  `TrackingLinksByRecipientTableName` text NOT NULL,
  `TrackingUserAgentsTableName` text NOT NULL,
  `TrackingOSsTableName` text NOT NULL,

  `MaxEMailsToSend` int(11) NOT NULL default '100',
  `MaxEMailSize` int(11) NOT NULL default '10485760',

  `SendReportToDistribSenderEMailAddress` tinyint(1) NOT NULL default '0',
  `SendReportToYourSelf` tinyint(1) NOT NULL default '0',
  `SendReportToListAdmin` tinyint(1) NOT NULL default '0',
  `SendReportToMailingListUsers` tinyint(1) NOT NULL default '0',
  `SendReportToEMailAddress` tinyint(1) NOT NULL default '0',
  `SendReportToEMailAddressEMailAddress` text NOT NULL,

  `PersonalizeEMails` tinyint(1) NOT NULL default '1',
  `TrackLinks` tinyint(1) NOT NULL default '0',
  `TrackLinksByRecipient` tinyint(1) NOT NULL default '0',
  `TrackEMailOpenings` tinyint(1) NOT NULL default '0',
  `TrackEMailOpeningsByRecipient` tinyint(1) NOT NULL default '0',
  `TrackEMailOpeningsImageURL` text NOT NULL,
  `TrackEMailOpeningsByRecipientImageURL` text NOT NULL,
  `TrackingIPBlocking` tinyint(1) NOT NULL default '0',
  `GoogleAnalyticsActive` tinyint(1) NOT NULL default '0',
  `GoogleAnalytics_utm_source` text NOT NULL,
  `GoogleAnalytics_utm_medium` text NOT NULL,
  `GoogleAnalytics_utm_term` text NOT NULL,
  `GoogleAnalytics_utm_content` text NOT NULL,
  `GoogleAnalytics_utm_campaign` text NOT NULL,

  `OverwriteSenderAddress` tinyint(1) NOT NULL default '0',
  `SenderFromName` text NOT NULL,
  `SenderFromAddress` text NOT NULL,
  `ReplyToEMailAddress` text NOT NULL,
  `ReturnPathEMailAddress` text NOT NULL,
  `CcEMailAddresses` text NOT NULL,
  `BCcEMailAddresses` text NOT NULL,
  `ReturnReceipt` tinyint(1) NOT NULL default '0',
  `BCCSending` tinyint(1) NOT NULL default '0',
  `BCCRecipientsCount` tinyint(4) NOT NULL default '10',
  `BCCSenderEMailAddress` text NOT NULL,

  `MailPreHeaderText` text NOT NULL,

  `AutoCreateTextPart` tinyint(1) NOT NULL default '0',
  `Caching` tinyint(1) NOT NULL default '1',
  `IgnoreHeaderXLoop` tinyint(1) NOT NULL default '1',
  `AddXLoop` tinyint(1) NOT NULL default '1',
  `AddListUnsubscribe` tinyint(1) NOT NULL default '1',

  `NoEMailToDistribSenderEMailAddress` tinyint(1) NOT NULL default '0',

  `DistribListConfirmationLinkMailSubject` text NOT NULL,
  `DistribListConfirmationLinkMailPlainText` mediumtext NOT NULL,
  `DistribListSenderInfoMailSubject` text NOT NULL,
  `DistribListSenderInfoMailPlainText` mediumtext NOT NULL,
  `DistribListSenderInfoConfirmMailSubject` text NOT NULL,
  `DistribListSenderInfoConfirmMailPlainText` mediumtext NOT NULL,

  `AddSignature` tinyint(1) NOT NULL default '0',
  `SignatureHTMLText` mediumtext NOT NULL,
  `SignaturePlainText`mediumtext NOT NULL,

  PRIMARY KEY  (`id`),
  KEY `Name` (`Name`)
);

CREATE TABLE IF NOT EXISTS `TABLE_DISTRIB_LISTS_ENTRIES` (
  `id` int(11) NOT NULL auto_increment,
  `DistribList_id` int(11) NOT NULL,
  `CreateDate` datetime NOT NULL,

  `DistribSenderEMailAddress` text NOT NULL,

  `DistribSenderFromToCC` mediumtext NOT NULL,

  `SendConfirmationString` text NOT NULL,

  `SendScheduler` enum('ConfirmationPending','SaveOnly','SendImmediately','Sent') NOT NULL default 'SaveOnly',

  `SenderFromName` text NOT NULL,
  `SenderFromAddress` text NOT NULL,
  `ReplyToEMailAddress` text NOT NULL,
  `ReturnPathEMailAddress` text NOT NULL,
  `CcEMailAddresses` text NOT NULL,
  `BCcEMailAddresses` text NOT NULL,
  `ReturnReceipt` tinyint(1) NOT NULL default '0',
  `BCCSending` tinyint(1) NOT NULL default '0',
  `BCCRecipientsCount` tinyint(4) NOT NULL default '10',
  `BCCSenderEMailAddress` text NOT NULL,

  `UseInternalText` tinyint(1) NOT NULL default '1',
  `ExternalTextURL` text NOT NULL,

  `MailFormat` enum('PlainText','HTML','Multipart') NOT NULL default 'Multipart',
  `MailPriority` enum('Low','Normal','High') NOT NULL default 'Normal',
  `MailEncoding` varchar(20) NOT NULL default 'iso-8859-1',
  `MailSubject` text NOT NULL,
  `MailPlainText` mediumtext NOT NULL,
  `MailHTMLText` mediumtext NOT NULL,
  `Attachments` mediumtext NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `DistribList_id` (`DistribList_id`),
  KEY `SendConfirmationString` (`SendConfirmationString`(255))
);

CREATE TABLE IF NOT EXISTS `TABLE_LIMITSUBUNSUBSCRIPTS` (
  `CreateDate` datetime NOT NULL,
  `IP` varchar(64) default NULL,
  KEY `CreateDate` (`CreateDate`),
  KEY `IP` (`IP`)
);

CREATE TABLE IF NOT EXISTS `TABLE_OAUTH2APPS` (
  `id` int(11) NOT NULL auto_increment,
  `AppName` text NOT NULL,

  `AuthorizationEndpoint` text NOT NULL,
  `AccessTokenEndpoint` text NOT NULL,
  `LogoutEndpoint` text NOT NULL,
  `RevokeEndpoint` text NOT NULL,

  `ClientID` text NOT NULL,
  `ClientSecret` text NOT NULL,

  `Scope` text NOT NULL,

  `redirect_uri` text NOT NULL,

  `AdditionalAuthorizationURLParams` text NOT NULL,
  `AdditionalChangeAuthCodeToAccessTokenURLParams` text NOT NULL,

  `ServerInfo` mediumtext NOT NULL,
  PRIMARY KEY  (`id`)
);


CREATE TABLE IF NOT EXISTS `TABLE_OAUTH2CLIENTTOKENS` (
  `id` int(11) NOT NULL auto_increment,
  `OAuth2Apps_id` int(11) NOT NULL,
  `ClientAccountEMailAddress` varchar(255) NOT NULL,

  `access_token` mediumtext NOT NULL,
  `access_token_expires` datetime NOT NULL,

  `refresh_token` mediumtext NOT NULL,

  `scope` mediumtext NOT NULL,

  `token_type` VARCHAR(32) NOT NULL default 'Bearer',

  `ts` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),

  PRIMARY KEY  (`id`),
  UNIQUE KEY `OAuth2Apps_id_ClientAccountEMailAddress` (`OAuth2Apps_id`, `ClientAccountEMailAddress`(191))
);
